
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 85
#define YY_END_OF_BUFFER 86
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[406] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   86,   84,   83,   83,   84,   84,   84,   36,
       60,   84,   84,   84,   84,   65,   84,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   37,   38,
       59,   83,   60,   84,   84,   84,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   76,   75,
       75,   76,   76,   66,   68,   67,   73,   73,   73,   48,
       48,   47,   46,   45,   35,   33,   33,   35,   35,   35,
       11,   35,   14,   15,    9,   12,    8,   13,   10,   29,
       29,    3,   21,    7,   22,   34,   34,   34,   34,   34,

       34,   34,    0,    0,   82,    0,    0,   64,   64,   64,
       62,   70,   65,    0,   65,   65,   65,   65,    1,   65,
       65,   65,   65,   65,   65,   65,   65,    0,    0,    0,
        0,    0,    0,    0,    0,   64,    0,    0,    0,   65,
       65,   65,   65,   65,   65,    1,   65,   65,   65,   65,
       65,   65,   65,   65,    0,   69,    0,    0,   74,   67,
       73,   73,   72,   49,   45,   19,    0,   32,    0,    0,
       30,    0,   31,    0,   71,   27,    0,   29,   17,   20,
       16,   18,   34,   34,   34,   34,    4,   34,   34,    0,
       78,    0,   77,    0,    0,   80,    0,   64,   64,   61,

       61,   62,   63,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   42,   65,   65,   65,   58,    0,   81,   64,
        0,    0,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   42,   65,   65,   65,    0,    0,    0,   30,    0,
        0,   28,    5,   34,    6,   34,   34,    0,   79,   64,
       61,   61,   63,   65,   65,   41,   65,   65,   65,   65,
       65,   65,   40,   65,   65,    0,    0,    0,   65,   65,
       41,   65,   65,   65,   65,   65,   65,   40,   65,   65,
        0,    0,    0,    0,    0,   34,   34,    2,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   43,    0,    0,

       65,   65,   65,   65,   65,   65,   65,   65,   65,   43,
        0,   34,   34,   65,   65,   65,    0,   54,   65,   65,
       65,   65,   65,    0,    0,   65,   65,   65,   65,   65,
       65,   65,   65,   34,   34,    0,   56,   65,    0,   50,
        0,   55,   65,   65,   39,   65,    0,   57,   65,   65,
       65,   39,   65,   34,   34,   65,   65,   65,   65,   65,
       65,   65,   65,   23,   34,    0,   53,   65,    0,   52,
        0,   51,   65,   34,   34,   65,   65,   24,   25,   65,
       65,   34,   65,   65,   26,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,

       65,   65,   65,   44,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
        1,   53,    1,   29,   54,    1,   55,   56,   57,   58,

       59,   60,   61,   62,   63,   39,   39,   64,   65,   66,
       67,   68,   39,   69,   70,   71,   72,   49,   73,   74,
       75,   39,   76,   29,   77,   78,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[79] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,   18,    1,   19,
       20,   21,   21,   21,   19,   22,   22,   22,   22,   22,
       22,   23,   22,   22,   23,   22,   23,   22,   24,   22,
       25,   22,    6,   26,   19,   20,   21,   21,   21,   19,
       22,   22,   22,   22,   22,   23,   22,   22,   23,   22,
       23,   22,   22,   25,   22,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[467] =
    {   0,
        0,   78,  156,    0,  232,  233,  235,  238,  230,  235,
      257,    0, 1201, 2734, 2734, 2734,    0, 1191,    0, 2734,
     2734, 1147,  230,    0, 1136,    0,    0,  304,  295,  299,
      300,  306,  300,  299,  297,  312,  315,  309, 2734, 2734,
        0,  374,  332, 1134,  397,  365,  413,  438,  462,  317,
      350,  397,  312,  351,  399,  444,  447,  446, 2734, 2734,
     2734,  432, 1143, 2734, 2734,    0, 1142, 1140, 1110,    0,
     2734, 2734, 2734,  473, 2734, 2734, 2734, 1102,  443,  372,
     2734,  347, 2734, 2734, 2734, 2734, 2734, 2734, 1034,  448,
      480, 2734,  227,  932,  913,  353,    0,  398,  405,  452,

      457,  392,  505,  929, 2734,  529,  516,    0,  606,  351,
        0, 2734,    0,  890,  564,  570,  568,  572,    0,  572,
      403,  583,  579,  573,  578,  581,  577,  647,  506,  892,
      803,  607,    0,  611,  651,  670,  795,  644,  684,  590,
      638,  620,  626,  665,  594,  623,  659,  676,  678,  674,
      673,  672,  687,  690,  712, 2734,  423,  791, 2734,    0,
      710,  707, 2734,    0,  729, 2734,  716, 2734,  735,    0,
        0,  714, 2734,  738, 2734,  741,    0,  750, 2734, 2734,
     2734, 2734,    0,  720,  700,  716,    0,  738,  739,  772,
     2734,  638, 2734,  812,  777,  788,  631,  797,  621,    0,

        0,    0,    0,  739,  718,  748,  752,  843,  844,  849,
      850,  751,    0,  851,  852,  863,    0,  896, 2734,  899,
      494,  792,  890,  909,  875,  894,  889,  890,  897,  902,
      922,  896,  903,  908,  923,  968,  785,    0,    0,  963,
        0, 2734,    0,  904,    0,  932,  938,  522, 2734,  514,
        0,    0,    0,  942,  939,    0,  957,  943,  951,  949,
      961,  952,    0,  959,  953,  992,  998, 1001,  965,  979,
      961,  983,  981,  990,  988, 1009,  970,  991,  999,  995,
     1050, 1026,    0, 1052,    0,  989, 1012,    0, 1020, 1034,
     1027, 1072, 1043, 1037, 1036, 1048, 1055,    0,  614,  725,

     1046, 1060, 1047, 1096, 1063, 1077, 1049, 1067, 1094, 1068,
     1072, 1058, 1081, 1150, 1089, 1155, 1166, 2734, 1169, 1103,
     1085, 1092, 1094, 1130,  440, 1172, 1137, 1183, 1186, 1145,
     1146, 1150, 1153, 1138,  297, 1207, 2734, 1135, 1210, 2734,
     1223, 2734, 1170,  340,    0, 1174,  382,  350, 1190, 1199,
     1192, 1182, 1205, 1185, 1202, 1245, 1203, 1268, 1274, 1279,
     1241, 1286, 1290,  288, 1203, 1293, 2734, 1244, 1297, 2734,
     1310, 2734, 1270, 1205, 1266, 1272, 1283,    0,  283, 1275,
     1280, 1280, 1283, 1289,    0, 1281, 1291, 1296, 1317, 1282,
     1299, 1290, 1318, 1313, 1326, 1327, 1339, 1334, 1340, 1328,

     1334,  233, 1359, 2734, 2734, 1429, 1455, 1481, 1507, 1533,
     1541, 1566, 1592, 1610, 1624, 1648, 1666, 1684, 1709, 1729,
     1747, 1773, 1799, 1814, 1840, 1866, 1892, 1914, 1939, 1953,
     1979, 2005, 2025, 2046, 2071, 2094, 2114, 2138, 2153, 2179,
     2205, 2231, 2252, 2259, 2280, 2306, 2327, 2340, 2349, 2375,
     2401, 2427, 2453, 2479, 2505, 2531, 2557, 2579, 2601, 2619,
     2645, 2659, 2668, 2677, 2686, 2707
    } ;

static yyconst flex_int16_t yy_def[467] =
    {   0,
      405,  405,  405,    3,  406,  406,  407,  407,  408,  408,
      405,   11,  405,  405,  405,  405,  409,  410,  411,  405,
      405,  405,  412,  412,  413,  414,  415,  414,  414,  414,
      414,  414,  414,  414,  414,  414,  414,  414,  405,  405,
      412,  416,  417,  418,  419,  420,  421,  421,  421,   49,
       49,   49,   49,   49,   49,   49,   49,   49,  405,  405,
      405,  422,  423,  405,  405,  424,  425,  425,  405,  426,
      405,  405,  405,  405,  405,  405,  405,  405,  427,  428,
      405,  429,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  430,  430,  430,  430,  430,

      430,  430,  409,  410,  405,  405,  405,  412,  412,  431,
      432,  405,  414,  415,  414,  414,  414,  414,  414,  414,
      414,  414,  414,  414,  414,  414,  414,  416,  417,  418,
      433,  417,  434,  405,  418,  435,  433,  433,  436,   49,
      414,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,  422,  405,  437,  438,  405,  439,
      440,  440,  405,  441,  405,  405,  442,  405,  443,  444,
      445,  446,  405,  447,  405,  405,  448,  405,  405,  405,
      405,  405,  449,  449,  449,  449,  449,  449,  449,  405,
      405,  450,  405,  405,  405,  405,  451,  452,  453,  454,

      455,  456,  457,  414,  414,  414,  414,  414,  414,  414,
      414,  414,  414,  414,  414,  414,  458,  405,  405,  452,
      405,  459,  460,  460,  224,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  461,  405,  462,  445,  405,
      463,  405,  449,  449,  449,  449,  449,  451,  405,  453,
      454,  455,  457,  414,  414,  414,  414,  414,  414,  414,
      414,  414,  414,  414,  414,  459,  459,  459,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      461,  405,  464,  405,  465,  449,  449,  449,  414,  414,
      414,  414,  414,  414,  414,  414,  414,  414,  405,  405,

      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      461,  449,  449,  414,  414,  414,  405,  405,  414,  414,
      414,  414,  414,  405,  466,  224,  224,  224,  224,  224,
      224,  224,  224,  449,  449,  405,  405,  414,  405,  405,
      405,  405,  414,  414,  414,  414,  466,  466,  224,  224,
      224,  224,  224,  449,  449,  414,  414,  414,  414,  224,
      224,  224,  224,  449,  449,  405,  405,  414,  405,  405,
      405,  405,  224,  449,  449,  414,  224,  449,  449,  414,
      224,  449,  414,  224,  449,  414,  224,  414,  224,  414,
      224,  414,  224,  414,  224,  414,  224,  414,  224,  414,

      224,  414,  224,  405,    0,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405
    } ;

static yyconst flex_int16_t yy_nxt[2813] =
    {   0,
       14,   15,   16,   15,   17,   14,   18,   19,   14,   20,
       14,   14,   14,   21,   22,   14,   23,   24,   25,   26,
       26,   26,   27,   14,   14,   14,   24,   24,   24,   28,
       26,   29,   26,   30,   26,   31,   26,   32,   26,   26,
       33,   26,   26,   34,   35,   36,   37,   38,   26,   26,
       26,   26,   14,   26,   28,   26,   29,   26,   30,   26,
       31,   26,   32,   26,   33,   26,   26,   34,   35,   36,
       37,   38,   26,   26,   26,   39,   40,   41,   14,   42,
       16,   42,   17,   14,   18,   19,   14,   20,   14,   14,
       14,   43,   44,   14,   45,   24,   25,   26,   26,   26,

       46,   14,   14,   14,   24,   24,   24,   47,   48,   49,
       48,   50,   48,   51,   48,   52,   48,   48,   53,   48,
       48,   54,   55,   56,   57,   58,   48,   48,   48,   48,
       14,   26,   47,   48,   49,   48,   50,   48,   51,   48,
       52,   48,   53,   48,   48,   54,   55,   56,   57,   58,
       48,   48,   48,   39,   40,   41,   59,   60,   61,   60,
       59,   62,   63,   59,   59,   59,   59,   59,   64,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   65,   59,   59,   59,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,

       66,   66,   66,   66,   66,   66,   66,   66,   59,   59,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
       66,   59,   59,   59,   68,   68,   71,   71,   71,   71,
       71,   71,   73,  109,  404,   69,   69,   73,  110,   74,
       74,   74,  179,  180,   74,   74,   74,   75,   76,   77,
       76,   78,   79,   75,   80,   81,   75,   82,   83,   84,
       85,   86,   87,   88,   75,   89,   90,   91,   91,   75,
       92,   93,   94,   95,   75,   75,   96,   97,   98,   97,
       97,   97,   97,   97,   97,   97,   97,   97,   99,  100,

       97,   97,  101,  102,   97,   97,   97,   97,   97,   75,
       75,   96,   97,   98,   97,   97,   97,   97,   97,   97,
       97,   97,   99,  100,   97,   97,  101,  102,   97,   97,
       97,   97,   75,   75,   75,  115,  382,  116,  117,  118,
      119,  374,  121,  122,  123,  124,  355,  120,  126,  133,
      127,  134,  134,  201,  148,  348,  144,  173,  125,  140,
      115,  116,  117,  118,  108,  119,  121,  122,  123,  355,
      124,  120,  137,  126,  127,  128,  170,  128,  148,  170,
      144,  138,  125,  140,  114,  114,  114,  348,  130,  145,
      130,  358,  140,  140,  184,  149,  131,  108,  108,  174,

      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      109,  108,  108,  145,  358,  110,  140,  140,  184,  149,
      108,  108,  108,  108,  108,  108,  132,  113,  189,  113,
      133,  146,  141,  141,  113,  209,  113,  156,  147,  140,
      185,  140,  236,  236,  142,  348,  150,  186,  168,  108,
      108,  132,  113,  189,  113,  133,  146,  141,  141,  113,
      209,  113,  147,  140,  185,  140,  113,  176,  176,  142,
      150,  186,  108,  108,  108,  132,  113,  151,  113,  133,
      153,  141,  141,  113,  157,  113,  140,  154,  140,  140,
      152,  113,  165,  165,  165,  169,  187,  221,  177,  178,

      178,  178,  151,  188,  143,  153,  190,  191,  190,  222,
      140,  154,  140,  140,  152,  113,  249,  195,  196,  195,
      187,  177,  197,  133,  249,  134,  134,  188,  143,  192,
      192,  193,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  192,  192,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,

      194,  194,  194,  194,  192,  192,  192,  198,  196,  198,
      204,  205,  199,  206,  207,  208,  210,  299,  212,  213,
      214,  215,  216,  249,  133,  211,  134,  134,  133,  300,
      134,  134,  140,  249,  204,  205,  226,  206,  207,  208,
      193,  210,  212,  213,  214,  215,  216,  221,  128,  211,
      128,  405,  218,  219,  218,  133,  140,  141,  141,  222,
      226,  130,  140,  130,  405,  140,  223,  224,  140,  131,
      108,  220,  219,  220,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  140,  221,  108,  140,
      223,  224,  140,  108,  108,  108,  108,  108,  108,  222,

      138,  140,  227,  114,  114,  114,  203,  140,  228,  162,
      225,  229,  162,  231,  233,  140,  140,  156,  140,  232,
      230,  168,  108,  108,  173,  140,  227,  234,  324,  140,
      325,  140,  140,  228,  225,  235,  229,  231,  233,  140,
      140,  244,  140,  232,  230,  108,  108,  108,  165,  165,
      165,  234,  243,  140,  237,  237,  140,  240,  240,  235,
      176,  176,  245,  255,  157,  244,  174,  246,  169,  178,
      178,  178,  247,  190,  191,  190,  254,  243,  195,  196,
      195,  256,  257,  197,  262,  238,  245,  255,  241,  195,
      196,  195,  246,  159,  197,  266,  267,  247,  198,  196,

      198,  254,  405,  199,  282,  282,  256,  257,  238,  262,
      137,  241,  192,  192,  193,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  192,  192,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  192,  192,  192,
      258,  259,  260,  261,  263,  264,  265,  218,  219,  218,

      220,  219,  220,  132,  113,  405,  113,  133,  271,  141,
      141,  113,  203,  113,  258,  259,  260,  261,  263,  264,
      140,  265,  132,  113,  272,  113,  133,  269,  141,  141,
      113,  105,  113,  271,  140,  140,  273,  274,  182,  140,
      275,  140,  140,  113,  140,  276,  278,  140,  140,  272,
      286,  279,  269,  140,  270,  277,  280,  181,  140,  140,
      273,  274,  113,  140,  275,  140,  140,  140,  140,  276,
      278,  140,  140,  156,  286,  279,  287,  140,  270,  288,
      277,  280,  284,  284,  289,  290,  291,  281,  281,  292,
      293,  140,  140,  294,  295,  266,  267,  296,  297,  298,

      287,  405,  405,  288,  299,  405,  140,  301,  289,  290,
      140,  291,  303,  292,  293,  308,  300,  294,  312,  295,
      157,  296,  297,  298,  140,  302,  140,  304,  140,  305,
      140,  301,  306,  140,  140,  140,  140,  303,  309,  308,
      140,  310,  307,  312,  140,  167,  167,  175,  140,  302,
      140,  304,  140,  305,  140,  156,  306,  140,  313,  140,
      140,  314,  309,  315,  140,  310,  316,  307,  140,  311,
      311,  172,  172,  317,  317,  317,  319,  156,  140,  320,
      321,  322,  313,  318,  323,  314,  328,  326,  315,  327,
      316,  140,  140,  331,  140,  334,  329,  317,  317,  317,

      332,  319,  157,  320,  321,  140,  322,  318,  140,  323,
      328,  326,  140,  140,  327,  140,  140,  331,  140,  330,
      334,  329,  140,  333,  157,  332,  335,  166,  163,  140,
      338,  344,  140,  324,  343,  325,  140,  140,  345,  140,
      346,  140,  162,  330,  162,  159,  140,  107,  333,  112,
      335,  336,  336,  336,  338,  344,  339,  339,  339,  343,
      107,  337,  345,  140,  346,  140,  340,  317,  317,  317,
      341,  341,  341,  336,  336,  336,  350,  318,  349,  354,
      342,  356,  140,  337,  339,  339,  339,  341,  341,  341,
      140,  140,  351,  105,  340,  140,  352,  342,  140,  353,

      405,  350,  349,  354,  357,  356,  140,  359,  336,  336,
      336,  339,  339,  339,  140,  140,  351,  140,  337,  140,
      352,  340,  140,  353,  341,  341,  341,  140,  140,  357,
      364,  140,  359,  361,  342,  140,  360,  140,  363,  365,
      368,  140,  378,  362,  140,  405,  366,  366,  366,  375,
      140,  140,  140,  405,  364,  140,  367,  405,  361,  140,
      360,  140,  405,  363,  365,  368,  362,  378,  140,  369,
      369,  369,  405,  375,  140,  371,  371,  371,  373,  370,
      366,  366,  366,  376,  405,  372,  140,  369,  369,  369,
      367,  371,  371,  371,  366,  366,  366,  370,  369,  369,

      369,  372,  379,  373,  367,  380,  405,  376,  370,  377,
      140,  371,  371,  371,  383,  140,  381,  385,  405,  384,
      386,  372,  388,  392,  140,  140,  387,  379,  140,  390,
      380,  140,  389,  377,  140,  140,  140,  394,  383,  140,
      393,  381,  385,  384,  140,  386,  388,  392,  140,  140,
      391,  387,  140,  396,  390,  140,  389,  398,  140,  140,
      140,  394,  140,  140,  393,  395,  397,  400,  140,  399,
      404,  140,  402,  401,  405,  391,  405,  396,  403,  140,
      405,  405,  398,  405,  140,  140,  140,  140,  405,  395,
      397,  405,  400,  405,  399,  140,  402,  405,  401,  405,

      405,  405,  403,  140,  140,  405,  405,  405,  140,  140,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  140,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,

       72,   72,   72,   72,   72,   72,   72,  103,  405,  405,
      405,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  106,
      106,  106,  106,  106,  106,  106,  108,  108,  405,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  111,  111,  111,  111,  111,  111,  111,  111,

      111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
      111,  111,  111,  111,  111,  111,  111,  111,  113,  113,
      113,  405,  113,  113,  405,  113,  405,  405,  113,  113,
      113,  113,  113,  113,  113,  113,  114,  114,  405,  405,
      405,  405,  114,  114,  114,  114,  114,  114,  114,  129,
      405,  129,  405,  405,  405,  129,  129,  405,  129,  405,
      405,  405,  129,  405,  405,  405,  129,  129,  129,  129,
      129,  129,  129,  132,  405,  132,  405,  132,  132,  405,
      405,  405,  405,  405,  132,  132,  132,  132,  132,  132,
      132,  135,  405,  405,  135,  135,  135,  135,  135,  405,

      405,  405,  135,  135,  135,  135,  135,  135,  135,  136,
      136,  405,  136,  136,  136,  136,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  136,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  139,  405,  405,  405,  139,
      405,  139,  139,  405,  405,  405,  405,  139,  139,  139,
      139,  139,  139,  139,  140,  140,  140,  140,  140,  140,
      140,  405,  140,  405,  405,  140,  140,  140,  140,  140,
      140,  140,  140,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  160,  160,  160,  405,  405,
      405,  405,  160,  160,  160,  160,  160,  160,  160,  160,
      161,  161,  161,  161,  161,  161,  161,  405,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  164,  405,  405,  405,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  167,  167,  167,  167,  167,  167,  405,  167,

      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  171,  405,
      171,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  171,  171,  171,  171,  171,  171,  171,  172,
      172,  172,  172,  172,  172,  172,  172,  172,  172,  172,
      172,  172,  172,  172,  172,  172,  172,  172,  172,  172,
      172,  172,  172,  172,  172,  183,  183,  405,  405,  405,
      405,  183,  183,  183,  183,  183,  183,  183,  183,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  202,  202,  405,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  138,  405,  405,  405,  138,  405,  405,  405,  405,
      405,  405,  405,  138,  138,  138,  138,  138,  138,  138,
      217,  405,  405,  217,  405,  217,  405,  217,  217,  405,
      405,  217,  217,  405,  217,  217,  217,  217,  217,  217,
      217,  136,  136,  136,  136,  136,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  136,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  136,  136,  139,  405,  405,

      405,  405,  405,  139,  139,  405,  139,  139,  139,  405,
      405,  405,  139,  139,  139,  139,  139,  139,  139,  155,
      405,  405,  405,  405,  405,  405,  155,  405,  405,  405,
      405,  155,  155,  155,  405,  405,  155,  155,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  160,  160,  160,  405,  405,  405,
      405,  160,  160,  160,  160,  160,  160,  160,  160,  161,
      161,  161,  161,  161,  161,  161,  405,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,

      161,  161,  161,  161,  161,  164,  405,  405,  405,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  167,  167,  167,  167,  167,  167,  405,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  405,
      405,  405,  405,  405,  167,  405,  405,  405,  405,  405,
      405,  167,  405,  405,  167,  405,  167,  171,  171,  171,
      171,  171,  171,  171,  239,  405,  405,  405,  405,  405,
      239,  239,  239,  239,  405,  405,  405,  405,  239,  239,

      239,  239,  239,  239,  239,  239,  172,  172,  172,  172,
      172,  172,  172,  172,  172,  172,  172,  172,  172,  172,
      172,  172,  172,  172,  172,  172,  172,  172,  172,  172,
      172,  172,  172,  172,  405,  405,  405,  405,  405,  172,
      405,  405,  405,  405,  405,  405,  172,  405,  405,  172,
      405,  172,  242,  405,  405,  405,  405,  405,  242,  242,
      242,  183,  183,  405,  405,  405,  405,  183,  183,  183,
      183,  183,  183,  183,  183,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,

      192,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  250,  250,  250,  250,  250,  250,  250,
      250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
      250,  250,  250,  250,  250,  250,  250,  250,  250,  251,
      251,  405,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,

      251,  251,  251,  251,  251,  252,  252,  405,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  202,  202,  405,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  253,  253,  405,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  217,  405,  405,  217,  405,  217,  405,
      217,  217,  405,  405,  217,  217,  405,  217,  217,  217,

      217,  217,  217,  217,  268,  268,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  268,
      268,  268,  268,  268,  268,  268,  140,  140,  140,  140,
      140,  140,  140,  405,  140,  405,  405,  140,  140,  140,
      140,  140,  140,  140,  140,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  283,  283,  405,  405,  405,  405,  283,  283,  283,
      285,  285,  405,  405,  405,  405,  285,  285,  285,  167,
      167,  405,  405,  405,  405,  167,  167,  167,  172,  172,

      405,  405,  405,  405,  172,  172,  172,  347,  347,  405,
      347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
      347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
      347,  347,  347,   13,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,

      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405
    } ;

static yyconst flex_int16_t yy_chk[2813] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    5,    6,    7,    7,    7,    8,
        8,    8,    9,   23,  402,    5,    6,   10,   23,    9,
        9,    9,   93,   93,   10,   10,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   28,  379,   29,   30,   31,
       32,  364,   33,   34,   35,   36,  335,   32,   37,   43,
       38,   43,   43,  110,   53,  348,   50,   82,   36,   50,
       28,   29,   30,   31,  110,   32,   33,   34,   35,  335,
       36,   32,   46,   37,   38,   42,   80,   42,   53,   80,
       50,   46,   36,   50,   46,   46,   46,  347,   42,   51,
       42,  344,   51,   54,   96,   54,   42,   45,   45,   82,

       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
       45,   45,   45,   51,  344,   45,   51,   54,   96,   54,
       45,   45,   45,   45,   45,   45,   47,   47,  102,   47,
       47,   52,   47,   47,   47,  121,   47,   62,   52,   52,
       98,   55,  157,  157,   47,  325,   55,   99,   79,   45,
       45,   48,   48,  102,   48,   48,   52,   48,   48,   48,
      121,   48,   52,   52,   98,   55,   47,   90,   90,   47,
       55,   99,   45,   45,   45,   49,   49,   56,   49,   49,
       57,   49,   49,   49,   62,   49,   56,   58,   58,   57,
       56,   48,   74,   74,   74,   79,  100,  221,   90,   91,

       91,   91,   56,  101,   49,   57,  103,  103,  103,  221,
       56,   58,   58,   57,   56,   49,  250,  107,  107,  107,
      100,   90,  107,  129,  248,  129,  129,  101,   49,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
      106,  106,  106,  106,  106,  106,  106,  106,  106,  106,

      106,  106,  106,  106,  106,  106,  106,  109,  109,  109,
      115,  116,  109,  117,  118,  120,  122,  299,  123,  124,
      125,  126,  127,  199,  132,  122,  132,  132,  134,  299,
      134,  134,  140,  197,  115,  116,  145,  117,  118,  120,
      192,  122,  123,  124,  125,  126,  127,  138,  128,  122,
      128,  138,  135,  135,  135,  141,  140,  141,  141,  138,
      145,  128,  142,  128,  135,  146,  142,  143,  143,  128,
      136,  136,  136,  136,  136,  136,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  136,  142,  139,  136,  146,
      142,  143,  143,  136,  136,  136,  136,  136,  136,  139,

      139,  147,  147,  139,  139,  139,  139,  144,  148,  162,
      144,  149,  161,  150,  152,  151,  150,  155,  148,  151,
      149,  167,  136,  136,  172,  147,  147,  153,  300,  153,
      300,  144,  154,  148,  144,  154,  149,  150,  152,  151,
      150,  185,  148,  151,  149,  136,  136,  136,  165,  165,
      165,  153,  184,  153,  169,  169,  154,  174,  174,  154,
      176,  176,  186,  205,  155,  185,  172,  188,  167,  178,
      178,  178,  189,  190,  190,  190,  204,  184,  195,  195,
      195,  206,  207,  195,  212,  169,  186,  205,  174,  196,
      196,  196,  188,  158,  196,  222,  222,  189,  198,  198,

      198,  204,  137,  198,  237,  237,  206,  207,  169,  212,
      131,  174,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      208,  209,  210,  211,  214,  215,  216,  218,  218,  218,

      220,  220,  220,  223,  223,  130,  223,  223,  225,  223,
      223,  223,  114,  223,  208,  209,  210,  211,  214,  215,
      225,  216,  224,  224,  226,  224,  224,  223,  224,  224,
      224,  104,  224,  225,  227,  228,  227,  228,   95,  226,
      229,  232,  229,  223,  225,  230,  233,  230,  233,  226,
      244,  234,  223,  234,  224,  231,  235,   94,  227,  228,
      227,  228,  224,  226,  229,  232,  229,  231,  235,  230,
      233,  230,  233,  236,  244,  234,  246,  234,  224,  247,
      231,  235,  240,  240,  254,  255,  257,  236,  236,  258,
      259,  231,  235,  260,  261,  266,  266,  262,  264,  265,

      246,  267,  267,  247,  268,  268,  271,  269,  254,  255,
      269,  257,  272,  258,  259,  277,  268,  260,  286,  261,
      236,  262,  264,  265,  270,  270,  273,  273,  272,  274,
      271,  269,  275,  275,  269,  274,  278,  272,  279,  277,
      280,  280,  276,  286,  279,  282,  282,   89,  270,  270,
      273,  273,  272,  274,  276,  281,  275,  275,  287,  274,
      278,  289,  279,  290,  280,  280,  291,  276,  279,  281,
      281,  284,  284,  292,  292,  292,  293,  311,  276,  294,
      295,  296,  287,  292,  297,  289,  303,  301,  290,  302,
      291,  301,  303,  307,  307,  312,  305,  304,  304,  304,

      308,  293,  281,  294,  295,  302,  296,  304,  305,  297,
      303,  301,  308,  310,  302,  301,  303,  307,  307,  306,
      312,  305,  306,  309,  311,  308,  313,   78,   69,  302,
      315,  321,  305,  324,  320,  324,  308,  310,  322,  309,
      323,  304,   68,  306,   67,   63,  306,   44,  309,   25,
      313,  314,  314,  314,  315,  321,  316,  316,  316,  320,
       22,  314,  322,  309,  323,  304,  316,  317,  317,  317,
      319,  319,  319,  326,  326,  326,  330,  317,  327,  334,
      319,  338,  327,  326,  328,  328,  328,  329,  329,  329,
      330,  331,  331,   18,  328,  332,  332,  329,  333,  333,

       13,  330,  327,  334,  343,  338,  327,  346,  336,  336,
      336,  339,  339,  339,  330,  331,  331,  326,  336,  332,
      332,  339,  333,  333,  341,  341,  341,  352,  328,  343,
      354,  329,  346,  350,  341,  349,  349,  351,  353,  355,
      357,  326,  374,  351,  350,    0,  356,  356,  356,  365,
      353,  352,  328,    0,  354,  329,  356,    0,  350,  349,
      349,  351,    0,  353,  355,  357,  351,  374,  350,  358,
      358,  358,    0,  365,  353,  359,  359,  359,  361,  358,
      360,  360,  360,  368,    0,  359,  361,  362,  362,  362,
      360,  363,  363,  363,  366,  366,  366,  362,  369,  369,

      369,  363,  375,  361,  366,  376,    0,  368,  369,  373,
      361,  371,  371,  371,  380,  373,  377,  382,    0,  381,
      383,  371,  386,  390,  360,  381,  384,  375,  377,  388,
      376,  362,  387,  373,  384,  363,  387,  392,  380,  373,
      391,  377,  382,  381,  391,  383,  386,  390,  360,  381,
      389,  384,  377,  394,  388,  362,  387,  396,  384,  363,
      387,  392,  389,  393,  391,  393,  395,  398,  391,  397,
      403,  395,  400,  399,    0,  389,    0,  394,  401,  401,
        0,    0,  396,    0,  397,  399,  389,  393,    0,  393,
      395,    0,  398,    0,  397,  395,  400,    0,  399,    0,

        0,    0,  401,  401,  403,    0,    0,    0,  397,  399,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  403,  406,
      406,  406,  406,  406,  406,  406,  406,  406,  406,  406,
      406,  406,  406,  406,  406,  406,  406,  406,  406,  406,
      406,  406,  406,  406,  406,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,

      408,  408,  408,  408,  408,  408,  408,  409,    0,    0,
        0,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  410,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  411,
      411,  411,  411,  411,  411,  411,  412,  412,    0,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  413,  413,  413,  413,  413,  413,  413,  413,

      413,  413,  413,  413,  413,  413,  413,  413,  413,  413,
      413,  413,  413,  413,  413,  413,  413,  413,  414,  414,
      414,    0,  414,  414,    0,  414,    0,    0,  414,  414,
      414,  414,  414,  414,  414,  414,  415,  415,    0,    0,
        0,    0,  415,  415,  415,  415,  415,  415,  415,  416,
        0,  416,    0,    0,    0,  416,  416,    0,  416,    0,
        0,    0,  416,    0,    0,    0,  416,  416,  416,  416,
      416,  416,  416,  417,    0,  417,    0,  417,  417,    0,
        0,    0,    0,    0,  417,  417,  417,  417,  417,  417,
      417,  418,    0,    0,  418,  418,  418,  418,  418,    0,

        0,    0,  418,  418,  418,  418,  418,  418,  418,  419,
      419,    0,  419,  419,  419,  419,  419,  419,  419,  419,
      419,  419,  419,  419,  419,  419,  419,  419,  419,  419,
      419,  419,  419,  419,  419,  420,    0,    0,    0,  420,
        0,  420,  420,    0,    0,    0,    0,  420,  420,  420,
      420,  420,  420,  420,  421,  421,  421,  421,  421,  421,
      421,    0,  421,    0,    0,  421,  421,  421,  421,  421,
      421,  421,  421,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  423,

      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  424,  424,  424,    0,    0,
        0,    0,  424,  424,  424,  424,  424,  424,  424,  424,
      425,  425,  425,  425,  425,  425,  425,    0,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  426,    0,    0,    0,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  427,  427,  427,  427,  427,  427,    0,  427,

      427,  427,  427,  427,  427,  427,  427,  427,  427,  427,
      427,  427,  427,  427,  427,  427,  427,  427,  428,    0,
      428,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  428,  428,  428,  428,  428,  428,  428,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  430,  430,    0,    0,    0,
        0,  430,  430,  430,  430,  430,  430,  430,  430,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,

      431,  431,  431,  431,  431,  432,  432,    0,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  433,    0,    0,    0,  433,    0,    0,    0,    0,
        0,    0,    0,  433,  433,  433,  433,  433,  433,  433,
      434,    0,    0,  434,    0,  434,    0,  434,  434,    0,
        0,  434,  434,    0,  434,  434,  434,  434,  434,  434,
      434,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  436,    0,    0,

        0,    0,    0,  436,  436,    0,  436,  436,  436,    0,
        0,    0,  436,  436,  436,  436,  436,  436,  436,  437,
        0,    0,    0,    0,    0,    0,  437,    0,    0,    0,
        0,  437,  437,  437,    0,    0,  437,  437,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  439,  439,  439,    0,    0,    0,
        0,  439,  439,  439,  439,  439,  439,  439,  439,  440,
      440,  440,  440,  440,  440,  440,    0,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,

      440,  440,  440,  440,  440,  441,    0,    0,    0,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  442,  442,  442,  442,  442,  442,    0,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  443,  443,    0,
        0,    0,    0,    0,  443,    0,    0,    0,    0,    0,
        0,  443,    0,    0,  443,    0,  443,  444,  444,  444,
      444,  444,  444,  444,  445,    0,    0,    0,    0,    0,
      445,  445,  445,  445,    0,    0,    0,    0,  445,  445,

      445,  445,  445,  445,  445,  445,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  447,  447,    0,    0,    0,    0,    0,  447,
        0,    0,    0,    0,    0,    0,  447,    0,    0,  447,
        0,  447,  448,    0,    0,    0,    0,    0,  448,  448,
      448,  449,  449,    0,    0,    0,    0,  449,  449,  449,
      449,  449,  449,  449,  449,  450,  450,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  450,  450,  450,

      450,  451,  451,  451,  451,  451,  451,  451,  451,  451,
      451,  451,  451,  451,  451,  451,  451,  451,  451,  451,
      451,  451,  451,  451,  451,  451,  451,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  454,
      454,    0,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,

      454,  454,  454,  454,  454,  455,  455,    0,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  456,  456,    0,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  457,  457,    0,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  458,    0,    0,  458,    0,  458,    0,
      458,  458,    0,    0,  458,  458,    0,  458,  458,  458,

      458,  458,  458,  458,  459,  459,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  459,
      459,  459,  459,  459,  459,  459,  460,  460,  460,  460,
      460,  460,  460,    0,  460,    0,    0,  460,  460,  460,
      460,  460,  460,  460,  460,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  462,  462,    0,    0,    0,    0,  462,  462,  462,
      463,  463,    0,    0,    0,    0,  463,  463,  463,  464,
      464,    0,    0,    0,    0,  464,  464,  464,  465,  465,

        0,    0,    0,    0,  465,  465,  465,  466,  466,    0,
      466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
      466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
      466,  466,  466,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,

      405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
      405,  405
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[86] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 
    0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 
    1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 61 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
//char *strdup(char*);
int fileno(FILE *stream);

#line 1338 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define EXPR 5

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 94 "lexer.l"


 /* keywords */
#line 1535 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 406 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2734 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 97 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 98 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 99 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 100 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 101 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 102 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 104 "lexer.l"
case 8:
#line 105 "lexer.l"
case 9:
#line 106 "lexer.l"
case 10:
#line 107 "lexer.l"
case 11:
#line 108 "lexer.l"
case 12:
#line 109 "lexer.l"
case 13:
#line 110 "lexer.l"
case 14:
#line 111 "lexer.l"
case 15:
YY_RULE_SETUP
#line 111 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 112 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 113 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 114 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 19:
#line 116 "lexer.l"
case 20:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 121 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 27:
#line 124 "lexer.l"
case 28:
#line 125 "lexer.l"
case 29:
YY_RULE_SETUP
#line 125 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 126 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
#line 127 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 32:
/* rule 32 can match eol */
YY_RULE_SETUP
#line 132 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 33:
/* rule 33 can match eol */
YY_RULE_SETUP
#line 137 "lexer.l"

	YY_BREAK
case 34:
YY_RULE_SETUP
#line 138 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 140 "lexer.l"
{ dbgprintf("invalid char in expr: %s\n", yytext); }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 141 "lexer.l"
{ return '&'; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 142 "lexer.l"
{ return '{'; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 143 "lexer.l"
{ return '}'; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 144 "lexer.l"
{ dbgprintf("RULESET\n"); }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 40:
YY_RULE_SETUP
#line 148 "lexer.l"
{ return STOP; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 149 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 150 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 151 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 152 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 153 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 154 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 47:
/* rule 47 can match eol */
YY_RULE_SETUP
#line 155 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 159 "lexer.l"

	YY_BREAK
case 49:
YY_RULE_SETUP
#line 160 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 163 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 165 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 167 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 169 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 171 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 173 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 175 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 176 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext)); return PROPFILT; }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 178 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 59:
#line 180 "lexer.l"
case 60:
#line 181 "lexer.l"
case 61:
/* rule 61 can match eol */
#line 182 "lexer.l"
case 62:
/* rule 62 can match eol */
#line 183 "lexer.l"
case 63:
/* rule 63 can match eol */
#line 184 "lexer.l"
case 64:
/* rule 64 can match eol */
#line 185 "lexer.l"
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 185 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 186 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 187 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 189 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 190 "lexer.l"
{
				  yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 193 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 194 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 195 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 196 "lexer.l"

	YY_BREAK
case 74:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 197 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 198 "lexer.l"

	YY_BREAK
case 76:
YY_RULE_SETUP
#line 199 "lexer.l"
{ dbgprintf("INOBJ: invalid char '%s'\n", yytext); }
	YY_BREAK
case 77:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 200 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 78:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 211 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 79:
/* rule 79 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 212 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 80:
/* rule 80 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 213 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 81:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 214 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 215 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 216 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 217 "lexer.l"
{ dbgprintf("invalid char: %s\n", yytext);
				}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(EXPR):
#line 219 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 221 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2092 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 406 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 406 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 405);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 221 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL)
		return 1; /* all processed */
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

